package com.ruoyi.yiqi.controller;

import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.annotation.RepeatSubmit;
import com.ruoyi.common.core.controller.BaseController;
//import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.validate.AddGroup;
import com.ruoyi.common.core.validate.EditGroup;
import com.ruoyi.common.core.validate.QueryGroup;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.common.utils.poi.ExcelUtil;
//import com.ruoyi.gas.domain.bo.GOtherEngineBo;
//import com.ruoyi.gas.domain.vo.GOtherEngineVo;
//import com.ruoyi.gas.service.IGOtherEngineService;
import com.ruoyi.yiqi.entity.YqGOtherEngine;
import com.ruoyi.yiqi.service.IYqGOtherEngineService;
//import io.swagger.annotations.Api;
//import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.Arrays;
import java.util.List;

/**
 * 其他工程Controller
 *
 * @author ruoyi
 * @date 2021-11-22
 */
@Validated
@RequiredArgsConstructor(onConstructor_ = @Autowired)
@RestController
@RequestMapping("/gas/otherEngine")
public class YqGOtherEngineController extends BaseController {

    @Resource
    private final IYqGOtherEngineService iGOtherEngineService;

    /**
     * 查询其他工程列表
     */
//    @ApiOperation("查询其他工程列表")
//    @PreAuthorize("@ss.hasPermi('gas:otherEngine:list')")
    @GetMapping("/list")
    public TableDataInfo<YqGOtherEngine> list(@Validated(QueryGroup.class) YqGOtherEngine bo) {
        return iGOtherEngineService.queryPageList(bo);
    }

    /**
     * 导出其他工程列表
     */
//    @ApiOperation("导出其他工程列表")
//    @PreAuthorize("@ss.hasPermi('gas:otherEngine:export')")
//    @Log(title = "其他工程", businessType = BusinessType.EXPORT)
//    @GetMapping("/export")
//    public void export(@Validated YqGOtherEngine bo, HttpServletResponse response) {
//        List<YqGOtherEngine> list = iGOtherEngineService.queryList(bo);
//        ExcelUtil.exportExcel(list, "其他工程", YqGOtherEngine.class, response);
//    }

    /**
     * 获取其他工程详细信息
     */
//    @ApiOperation("获取其他工程详细信息")
//    @PreAuthorize("@ss.hasPermi('gas:otherEngine:query')")
    @GetMapping("/{id}")
    public R<YqGOtherEngine> getInfo(@NotNull(message = "主键不能为空")
                                                  @PathVariable("id") Long id) {
        return R.ok(iGOtherEngineService.getById(id));
    }
}
