package com.ruoyi.yiqi.controller;

import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.annotation.RepeatSubmit;
import com.ruoyi.common.core.controller.BaseController;
//import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.validate.AddGroup;
import com.ruoyi.common.core.validate.EditGroup;
import com.ruoyi.common.core.validate.QueryGroup;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.common.utils.poi.ExcelUtil;
//import com.ruoyi.gas.domain.bo.GPipeTypeBo;
//import com.ruoyi.gas.domain.vo.GPipeTypeVo;
//import com.ruoyi.gas.service.IGPipeTypeService;
import com.ruoyi.yiqi.entity.YqGPipeType;
import com.ruoyi.yiqi.service.IYqGPipeTypeService;
//import io.swagger.annotations.Api;
//import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.Arrays;
import java.util.List;

/**
 * 管子类别Controller
 *
 * @author ruoyi
 * @date 2021-11-16
 */
@Validated
//@Api(value = "管子类别控制器", tags = {"管子类别管理"})
@RequiredArgsConstructor(onConstructor_ = @Autowired)
@RestController
@RequestMapping("/gas/pipeType")
public class YqGPipeTypeController extends BaseController {

    private final IYqGPipeTypeService iGPipeTypeService;

    /**
     * 查询管子类别列表
     */
//    @ApiOperation("查询管子类别列表")
//    @PreAuthorize("@ss.hasPermi('gas:pipeType:list')")
    @GetMapping("/list")
    public TableDataInfo<YqGPipeType> list(@Validated(QueryGroup.class) YqGPipeType bo) {
        return iGPipeTypeService.queryPageList(bo);
    }

    /**
     * 导出管子类别列表
     */
//    @ApiOperation("导出管子类别列表")
//    @PreAuthorize("@ss.hasPermi('gas:pipeType:export')")
//    @Log(title = "管子类别", businessType = BusinessType.EXPORT)
//    @GetMapping("/export")
//    public void export(@Validated YqGPipeType bo, HttpServletResponse response) {
//        List<YqGPipeType> list = iGPipeTypeService.queryList(bo);
//        ExcelUtil.exportExcel(list, "管子类别", YqGPipeType.class, response);
//    }

    /**
     * 获取管子类别详细信息
     */
//    @ApiOperation("获取管子类别详细信息")
//    @PreAuthorize("@ss.hasPermi('gas:pipeType:query')")
    @GetMapping("/{id}")
    public R<YqGPipeType> getInfo(@NotNull(message = "主键不能为空")
                                                  @PathVariable("id") Long id) {
        return R.ok(iGPipeTypeService.queryById(id));
    }

//    @GetMapping("/getList")
//    public AjaxResult getList() {
//        return AjaxResult.success(iGPipeTypeService.list());
//    }
}
