package com.ruoyi.yiqi.entity;

import com.alibaba.excel.annotation.ExcelIgnoreUnannotated;
import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.annotation.ExcelDictFormat;
import com.ruoyi.common.convert.ExcelDictConvert;
import lombok.Data;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Locale;
import java.util.TimeZone;


/**
 * 工程管理视图对象 g_order
 *
 * @author ruoyi
 * @date 2021-11-16
 */
@Data
@ExcelIgnoreUnannotated
public class GOrderVo {

	private static final long serialVersionUID = 1L;
	SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss", Locale.CHINA);

    /**
     * 主键id
     */
	private Long id;
	private Long anjianId;

    /**
     * 订单号
     */
	private String orderNum;

	/**
	 * 服务类别
	 * 字典 ：001 上门未遇 002 正常施工 003 不符合规定
	 * 非字典 004安检 005维修  006开栓
	 */
    @ExcelProperty(value = "服务类别", converter = ExcelDictConvert.class)
    @ExcelDictFormat(dictType = "service_type")
	private String serviceType;

	@ExcelProperty(value = "工人")
	private String userName;

	private Long userId;

	@ExcelProperty(value = "房屋")
	private String house;
    /**
     * 房屋id
     */
	private Long houseId;

	private Long unitId;
	private Long buildingId;
	private Long areaId;
	/**
	 * 管子类别
	 */
	@ExcelProperty(value = "管子类别")
	private String pipeType;
	/**
	 * 管子长度
	 */
	@ExcelProperty(value = "管子长度")
	private String pipeLength;
	@ExcelProperty(value = "自闭阀类型")
	private String valveType;
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
	private Date time;
	@ExcelProperty(value = "修改时间")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
	private Date updateTime;
    /**
     * 订单状态
     */
    @ExcelProperty(value = "工程状态", converter = ExcelDictConvert.class)
    @ExcelDictFormat(dictType = "order_status")
	private String orderStatus;

    /**
     * 审核状态
     */
    @ExcelProperty(value = "审核状态", converter = ExcelDictConvert.class)
    @ExcelDictFormat(dictType = "examine_status")
	private String examineStatus;

    /**
     * 备注
     */
	@ExcelProperty(value = "备注")
	private String remark;
	/**
	 * 审核意见
	 */
	@ExcelProperty(value = "意见")
	private String reason;

	private Integer version;
	private String whether;


	private List<String> photoList;

	@ExcelProperty(value = "创建时间")
	private String exportTime;

	public String getExportTime() {
		return exportTime;
	}

	public void setExportTime(Date exportTime) {
		this.exportTime = DateToString(exportTime);
	}

	/**
			* date类型时间转String类型时间（设置时区）
			* @param time
     * @return
			 */
	public static String DateToString(Date time){
		TimeZone timeZoneSH = TimeZone.getTimeZone("Asia/Shanghai");
		SimpleDateFormat outputFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss", Locale.CHINA);
		outputFormat.setTimeZone(timeZoneSH);
		return outputFormat.format(time);
	}
}
