package com.ruoyi.yiqi.service;


import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.yiqi.entity.YqGHouse;

import java.util.Collection;
import java.util.List;

/**
 * 房屋Service接口
 *
 * @author ruoyi
 * @date 2021-11-15
 */
public interface IYqGHouseService extends IService<YqGHouse> {
	/**
	 * 查询单个
	 * @return
	 */
	YqGHouse queryById(Long id);

	/**
	 * 查询列表
	 */
    TableDataInfo<YqGHouse> queryPageList(YqGHouse bo);

	/**
	 * 查询列表
	 */
	List<YqGHouse> queryList(YqGHouse bo);

	/**
	 * 根据新增业务对象插入房屋
	 * @param bo 房屋新增业务对象
	 * @return
	 */
	Boolean insertByBo(YqGHouse bo);

	/**
	 * 根据编辑业务对象修改房屋
	 * @param bo 房屋编辑业务对象
	 * @return
	 */
	Boolean updateByBo(YqGHouse bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

	TableDataInfo<YqGHouse> getList(YqGHouse bo);

	YqGHouse getById(Long id);

	List<YqGHouse> getHouse(Long unitId);
}
