package com.ruoyi.yiqi.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
//import com.ruoyi.common.core.mybatisplus.core.ServicePlusImpl;
import com.ruoyi.common.core.page.PagePlus;
import com.ruoyi.common.core.page.TableDataInfo;
//import com.ruoyi.common.enums.Constants;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.PageUtils;
import com.ruoyi.common.utils.StringUtils;
//import com.ruoyi.gas.domain.GOrder;
//import com.ruoyi.gas.domain.GOrderPhoto;
//import com.ruoyi.gas.domain.bo.GOrderBo;
//import com.ruoyi.gas.domain.vo.*;
//import com.ruoyi.gas.mapper.GOrderMapper;
//import com.ruoyi.gas.mapper.GOrderPhotoMapper;
//import com.ruoyi.gas.service.IGOrderService;
import com.ruoyi.yiqi.entity.*;
import com.ruoyi.yiqi.enums.Constants;
import com.ruoyi.yiqi.mapper.YqGOrderMapper;
import com.ruoyi.yiqi.mapper.YqGOrderPhotoMapper;
import com.ruoyi.yiqi.service.IYqGOrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 工程管理Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-16
 */
@Service
public class YqGOrderServiceImpl implements IYqGOrderService {
    @Resource
    private YqGOrderMapper gOrderMapper;
    @Resource
    private YqGOrderPhotoMapper gOrderPhotoMapper;

    @Override
    public YqGOrder queryById(Long id) {
        return gOrderMapper.getById(id);
    }

    @Override
    public TableDataInfo<YqGOrder> queryPageList(YqGOrder bo) {
        Page<YqGOrder> page = new Page<>(bo.getPageNum(), bo.getPageSize());
//        Page<YqGOrder> list = gOrderMapper.getList(bo, page);
        Page<YqGOrder> list = gOrderMapper.getListAll(bo, page);
        return PageUtils.buildDataInfo(list);


//        PagePlus<YqGOrder, YqGOrder> result = pageVo(PageUtils.buildPagePlus(), buildQueryWrapper(bo));
//        return PageUtils.buildDataInfo(result);
    }

//    @Override
//    public List<YqGOrder> queryList(YqGOrder bo) {
//        return listVo(buildQueryWrapper(bo));
//    }

//    private LambdaQueryWrapper<YqGOrder> buildQueryWrapper(YqGOrder bo) {
//        Map<String, Object> params = bo.getParams();
//        LambdaQueryWrapper<YqGOrder> lqw = Wrappers.lambdaQuery();
//        lqw.eq(StringUtils.isNotBlank(bo.getServiceType()), YqGOrder::getServiceType, bo.getServiceType());
//        lqw.eq(bo.getUserId() != null, YqGOrder::getUserId, bo.getUserId());
//        lqw.eq(StringUtils.isNotBlank(bo.getOrderStatus()), YqGOrder::getOrderStatus, bo.getOrderStatus());
//        lqw.eq(StringUtils.isNotBlank(bo.getExamineStatus()), YqGOrder::getExamineStatus, bo.getExamineStatus());
//        return lqw;
//    }

    @Override
    public TableDataInfo<YqGOrder> getListAll(YqGOrder bo) {
        Page<YqGOrder> page = new Page<>(bo.getPageNum(), bo.getPageSize());
        Page<YqGOrder> list = gOrderMapper.getListAll(bo, page);
        //查看照片
        list.getRecords().forEach(i -> {
            List<String> picUrl = gOrderPhotoMapper.getPicUrl(i.getId());
            i.setPhotoList(picUrl);
        });
        return PageUtils.buildDataInfo(list);
    }

    @Override
    public TableDataInfo<YqGOrder> getListExamine(YqGOrder bo) {
        Page<YqGOrder> page = new Page<>(bo.getPageNum(), bo.getPageSize());
        Page<YqGOrder> list = gOrderMapper.getListExamine(bo, page);
        //查看照片
        list.getRecords().forEach(i -> {
            List<String> picUrl = gOrderPhotoMapper.getPicUrl(i.getId());
            i.setPhotoList(picUrl);
        });
        return PageUtils.buildDataInfo(list);
    }

    @Override
    public YqGOrder getById(Long id) {
        YqGOrder vo = gOrderMapper.getById(id);
        List<String> picUrl = gOrderPhotoMapper.getPicUrl(vo.getId());
        if (picUrl.size() > 0) {
            vo.setPhotoList(picUrl);
        }
        return vo;
    }

    @Override
    public Long getByIdAndVersion(Long id,Integer version) {
        return gOrderMapper.getByIdAndVersion(id,version);
    }

    @Override
    public List<YqGCensusVo> getExaminePipeType(Long id) {
        List<YqGCensusVo> list1 = gOrderMapper.getExaminePipeType(id);
        List<YqGCensusVo> list = new ArrayList<>();
        list1.forEach(i -> {
            if (StringUtils.isNotEmpty(i.getName())) {
                list.add(i);
            }
        });
        return list;
    }

    @Override
    public List<YqGCensusVo> getExaminePipeLength(Long id) {
        List<YqGCensusVo> list1 = gOrderMapper.getExaminePipeLength(id);
        List<YqGCensusVo> list = new ArrayList<>();
        list1.forEach(i -> {
            if (StringUtils.isNotEmpty(i.getName())) {
                list.add(i);
            }
        });
        return list;
    }

    @Override
    public List<YqGCensusVo> getExamineValveType(Long id) {
        List<YqGCensusVo> list1 = gOrderMapper.getExamineValveType(id);
        List<YqGCensusVo> list = new ArrayList<>();
        list1.forEach(i -> {
            if (StringUtils.isNotEmpty(i.getName())) {
                list.add(i);
            }
        });
        return list;
    }

    @Override
    public Boolean getOrderForStatus(Long houseId, String id) {
        YqGOrder vo = gOrderMapper.getOrderForStatus(houseId, id);
        if (vo == null) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public TableDataInfo<YqGOrder> getListByStatus(YqGOrder bo) {
        if (Constants.Dict.EXAMINE_STATUS001.getItemName().equals(bo.getValue())) {
            bo.setValue(Constants.Dict.EXAMINE_STATUS001.getItemValue());
        }
        if (Constants.Dict.EXAMINE_STATUS002.getItemName().equals(bo.getValue())) {
            bo.setValue(Constants.Dict.EXAMINE_STATUS002.getItemValue());
        }
        Page<YqGOrder> page = new Page<>(bo.getPageNum(), bo.getPageSize());
        Page<YqGOrder> list = gOrderMapper.getListByStatus(bo, page);
        //查看照片
        list.getRecords().forEach(i -> {
            List<String> picUrl = gOrderPhotoMapper.getPicUrl(i.getId());
            i.setPhotoList(picUrl);
        });
        return PageUtils.buildDataInfo(list);
    }

    @Override
    public List<GOrderVo> getListExport(YqGOrder bo) {
        return gOrderMapper.getListExport(bo);
    }

    @Override
    public TableDataInfo<YqGOrder> getListAnJian(YqGOrder bo) {
        Page<YqGOrder> page = new Page<>(bo.getPageNum(), bo.getPageSize());
        Page<YqGOrder> list = gOrderMapper.getListAnJian(bo, page);
        //查看照片
        list.getRecords().forEach(i -> {
            List<String> picUrl = gOrderPhotoMapper.getPicUrl(i.getId());
            i.setPhotoList(picUrl);
        });
        return PageUtils.buildDataInfo(list);
    }

    @Override
    public TableDataInfo<YqGOrder> getListWeiXiu(YqGOrder bo) {
        Page<YqGOrder> page = new Page<>(bo.getPageNum(), bo.getPageSize());
        Page<YqGOrder> list = gOrderMapper.getListWeiXiu(bo, page);
        //查看照片
        list.getRecords().forEach(i -> {
            List<String> picUrl = gOrderPhotoMapper.getPicUrl(i.getId());
            i.setPhotoList(picUrl);
        });
        return PageUtils.buildDataInfo(list);
    }

    @Override
    public TableDataInfo<YqGOrder> getListKaiShuan(YqGOrder bo) {
        Page<YqGOrder> page = new Page<>(bo.getPageNum(), bo.getPageSize());
        Page<YqGOrder> list = gOrderMapper.getListKaiShuan(bo, page);
        //查看照片
        list.getRecords().forEach(i -> {
            List<String> picUrl = gOrderPhotoMapper.getPicUrl(i.getId());
            i.setPhotoList(picUrl);
        });
        return PageUtils.buildDataInfo(list);
    }

    @Override
    public List<YqGOrderExportVoAnJian> getListAnJianExport(YqGOrder bo) {
        return gOrderMapper.getListAnJianExport(bo);
    }

    @Override
    public List<YqGOrderExportVoWeiXiu> getListWeiXiuExport(YqGOrder bo) {
        return gOrderMapper.getListWeiXiuExport(bo);
    }
}
