package com.ruoyi.yiqi.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.utils.PageUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.yiqi.entity.YqGUnit;
import com.ruoyi.yiqi.mapper.YqGUnitMapper;
import com.ruoyi.yiqi.service.IYqGUnitService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.*;
import java.util.function.Function;

/**
 * 单元Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-15
 */
@Service
public class YqGUnitServiceImpl implements IYqGUnitService {

    @Resource
    private YqGUnitMapper gUnitMapper;

    private LambdaQueryWrapper<YqGUnit> buildQueryWrapper(YqGUnit bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<YqGUnit> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotEmpty(bo.getName()), YqGUnit::getName, bo.getName());
        lqw.eq(bo.getBuildingId() != null, YqGUnit::getBuildingId, bo.getBuildingId());
        return lqw;
    }

    @Override
    public Boolean insertByBo(YqGUnit bo) {
        YqGUnit add = BeanUtil.toBean(bo, YqGUnit.class);
        boolean flag = false;
        Long count = gUnitMapper.checkDataList(bo);
        if (count == 0) {
            flag = save(add);
            if (flag) {
                bo.setId(add.getId());
            }
        }

        return flag;
    }

    @Override
    public Boolean updateByBo(YqGUnit bo) {
        YqGUnit update = BeanUtil.toBean(bo, YqGUnit.class);
        validEntityBeforeSave(update);
        return updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(YqGUnit entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return removeByIds(ids);
    }

    @Override
    public TableDataInfo<YqGUnit> getList(YqGUnit bo) {
        Page<YqGUnit> page = new Page<>(bo.getPageNum(), bo.getPageSize());
        Page<YqGUnit> list = gUnitMapper.getList(bo, page);
        return PageUtils.buildDataInfo(list);
    }

    @Override
    public YqGUnit getById(Long id) {
        return gUnitMapper.getById(id);
    }

    @Override
    public List<YqGUnit> getUnit(Long buildingId) {
        return gUnitMapper.getUnit(buildingId);
    }

    @Override
    public YqGUnit queryById(Long id) {
        return null;
    }

    @Override
    public TableDataInfo<YqGUnit> queryPageList(YqGUnit bo) {
        return null;
    }

    @Override
    public List<YqGUnit> queryList(YqGUnit bo) {
        return new ArrayList<>();
    }

    @Override
    public boolean saveBatch(Collection<YqGUnit> entityList, int batchSize) {
        return false;
    }

    @Override
    public boolean saveOrUpdateBatch(Collection<YqGUnit> entityList, int batchSize) {
        return false;
    }

    @Override
    public boolean updateBatchById(Collection<YqGUnit> entityList, int batchSize) {
        return false;
    }

    @Override
    public boolean saveOrUpdate(YqGUnit entity) {
        return false;
    }

    @Override
    public YqGUnit getOne(Wrapper<YqGUnit> queryWrapper, boolean throwEx) {
        return null;
    }

    @Override
    public Optional<YqGUnit> getOneOpt(Wrapper<YqGUnit> queryWrapper, boolean throwEx) {
        return Optional.empty();
    }

    @Override
    public Map<String, Object> getMap(Wrapper<YqGUnit> queryWrapper) {
        return new HashMap<>();
    }

    @Override
    public <V> V getObj(Wrapper<YqGUnit> queryWrapper, Function<? super Object, V> mapper) {
        return null;
    }

    @Override
    public BaseMapper<YqGUnit> getBaseMapper() {
        return null;
    }

    @Override
    public Class<YqGUnit> getEntityClass() {
        return null;
    }
}
