package com.ruoyi.yiqi.service.impl;



import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.utils.PageUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.yiqi.entity.YqGUser;
import com.ruoyi.yiqi.enums.Constants;
import com.ruoyi.yiqi.mapper.YqGUserMapper;
import com.ruoyi.yiqi.service.IYqGUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.function.Function;

/**
 * 用户Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-12
 */
@Service
public class YqGUserServiceImpl  implements IYqGUserService {

    @Autowired
    private YqGUserMapper gUserMapper;

    @Override
    public YqGUser queryById(Long id){
        return gUserMapper.selectVoById(id);
    }

    @Override
    public TableDataInfo<YqGUser> queryPageList(YqGUser bo) {
        Page<YqGUser> page = new Page<>(bo.getPageNum(), bo.getPageSize());
        Page<YqGUser> list = gUserMapper.getList(bo,page);
        return PageUtils.buildDataInfo(list);
    }

    @Override
    public List<YqGUser> queryList(YqGUser bo) {
        return gUserMapper.selectVoList(buildQueryWrapper(bo));
    }

    private LambdaQueryWrapper<YqGUser> buildQueryWrapper(YqGUser bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<YqGUser> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getName()), YqGUser::getName, bo.getName());
        lqw.like(bo.getJobNum() != null, YqGUser::getJobNum, bo.getJobNum());
        return lqw;
    }

    @Override
    public Boolean insertByBo(YqGUser add) {
        boolean flag = save(add);
        return flag;
    }

    @Override
    public Boolean updateByBo(YqGUser bo) {
        YqGUser update = BeanUtil.toBean(bo, YqGUser.class);
        validEntityBeforeSave(update);
        return updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(YqGUser entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return removeByIds(ids);
    }

    @Override
    public TableDataInfo<YqGUser> getList(YqGUser bo) {
        Page<YqGUser> page = new Page<>(bo.getPageNum(), bo.getPageSize());
        Page<YqGUser> list = gUserMapper.getList(bo,page);
        return PageUtils.buildDataInfo(list);

    }


    @Override
    public List<YqGUser> getWorker() {
        return gUserMapper.getWorker();
    }

    @Override
    public TableDataInfo<YqGUser> getBlacklist(YqGUser bo) {
        Page<YqGUser> page = new Page<>(bo.getPageNum(), bo.getPageSize());
        Page<YqGUser> list = gUserMapper.getBlacklist(bo,page);
        return PageUtils.buildDataInfo(list);

    }

    @Override
    public List<YqGUser> getExamineForeman(Long foremanId) {
        List<YqGUser> list = gUserMapper.getExamineForeman(foremanId);
        list.forEach(i -> {
            if (Constants.Dict.EXAMINE_STATUS001.getItemValue().equals(i.getName())){
                i.setName(Constants.Dict.EXAMINE_STATUS001.getItemName());
            }
            if (Constants.Dict.EXAMINE_STATUS002.getItemValue().equals(i.getName())){
                i.setName(Constants.Dict.EXAMINE_STATUS002.getItemName());
            }
        });
        return list;
    }

    @Override
    public List<YqGUser> getExamineWorker(Long workerId) {
        List<YqGUser> list = gUserMapper.getExamineWorker(workerId);
        list.forEach(i -> {
            if (Constants.Dict.EXAMINE_STATUS001.getItemValue().equals(i.getName())){
                i.setName(Constants.Dict.EXAMINE_STATUS001.getItemName());
            }
            if (Constants.Dict.EXAMINE_STATUS002.getItemValue().equals(i.getName())){
                i.setName(Constants.Dict.EXAMINE_STATUS002.getItemName());
            }
        });
        return list;
    }

    @Override
    public Boolean getForPhone(Long phone,String id) {
        YqGUser vo = gUserMapper.getForPhone(phone,id);
        if (vo==null){
            return true;
        }else {
            return false;
        }
    }

    @Override
    public Boolean getForJobnum(String jobNum,String id) {
        YqGUser vo = gUserMapper.getForJobnum(jobNum,id);
        if (vo==null){
            return true;
        }else {
            return false;
        }
    }

    @Override
    public boolean saveBatch(Collection<YqGUser> entityList, int batchSize) {
        return false;
    }

    @Override
    public boolean saveOrUpdateBatch(Collection<YqGUser> entityList, int batchSize) {
        return false;
    }

    @Override
    public boolean updateBatchById(Collection<YqGUser> entityList, int batchSize) {
        return false;
    }

    @Override
    public boolean saveOrUpdate(YqGUser entity) {
        return false;
    }

    @Override
    public YqGUser getOne(Wrapper<YqGUser> queryWrapper, boolean throwEx) {
        return null;
    }

    @Override
    public Optional<YqGUser> getOneOpt(Wrapper<YqGUser> queryWrapper, boolean throwEx) {
        return Optional.empty();
    }

    @Override
    public Map<String, Object> getMap(Wrapper<YqGUser> queryWrapper) {
        return new HashMap<>();
    }

    @Override
    public <V> V getObj(Wrapper<YqGUser> queryWrapper, Function<? super Object, V> mapper) {
        return null;
    }

    @Override
    public BaseMapper<YqGUser> getBaseMapper() {
        return null;
    }

    @Override
    public Class<YqGUser> getEntityClass() {
        return null;
    }
}
