package com.ruoyi.zdsz.domain.vo;

import com.alibaba.excel.annotation.ExcelIgnoreUnannotated;
import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.ruoyi.common.annotation.ExcelDictFormat;
import com.ruoyi.common.convert.ExcelDictConvert;
import com.ruoyi.common.core.domain.BaseEntity;
import com.ruoyi.zdsz.domain.bo.ZEngineeringNodeBo;
import lombok.Data;

import java.util.List;

/**
 * 开栓施工视图对象 z_engineering_gas_opening
 *
 * @author ruoyi
 * @date 2024-01-02
 */
@Data
@ExcelIgnoreUnannotated
public class ZEngineeringGasOpeningVo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     *
     */
    private String id;
    @ExcelProperty(value = "是否合格", converter = ExcelDictConvert.class)
    @ExcelDictFormat(dictType = "gas_state")
    private String state;

    /**
     * 工程类型
     */

    private String enginType;

    /**
     * 行政区
     */
    private String district;
    @ExcelProperty(value = "行政区")
    private String districtName;
    /**
     * 小区id
     */
    private String areaId;
    @ExcelProperty(value = "小区")
    private String areaName;
    /**
     * 楼栋id
     */
    private String buildingId;
    @ExcelProperty(value = "楼栋")
    private String buildingName;
    /**
     * 单元id
     */
    private String unitId;
    @ExcelProperty(value = "单元")
    private String unitName;
    /**
     * 房间id
     */
    private String houseId;
    @ExcelProperty(value = "房间")
    private String houseName;
    @ExcelProperty(value = "现住人电话")
    private String newPhone;

    /**
     * 立杠是否刷涂防腐漆
     */
    private String isAntiCorrosionPaint;
    /**
     * 是否有立杠卡子
     */
    private String isVerticalBarClamp;
    /**
     * 立杠气密测试
     */
    private String verticalBarTest;
    /**
     * 单户气密测试
     */
    private String householdTest;
    /**
     * 表号
     */
    private String gasMeterNumber;
    /**
     * 表字
     */
    private String gasMeterCount;
    /**
     * 品牌
     */
    private String gasMeterBrand;
    /**
     * 进气方向（左、右表）
     */
    private String gasMeterDirection;
    private String gasMeterDirectionName;
    /**
     * 型号
     */
    private String gasMeterType;
    /**
     * 管表后管是否有卡子固定
     */
    private String isRearPipeClamp;
    /**
     * 是否阀管改造（是、否） Y | N
     */
    private String isGasChangeType;
    /**
     * 是否阀管改造（全改、单改阀、单改管）
     */
    private String gasChangeType;
    private String gasChangeTypeName;
    /**
     * 是否使用防风圈
     */
    private String isWindproofCircle;

    /**
     * 燃气立杠
     */
//    private List<ZEngiineeringPhotoVo> gasCylinderPic;
    private List<String> gasCylinderPic;
    /**
     * 气密测试
     */
    private List<String> pressureTestPic;
    /**
     * 燃气表
     */
    private List<String> gasMeterPic;
    /**
     * 表后
     */
    private List<String> rearPipePic;
    /**
     * 灶前阀门
     */
    private List<String> gasChangePic;
    /**
     * 软管
     */
    private List<String> softPipePic;
    /**
     * 灶具
     */
    private List<String> windproofCirclePic;
    /**
     * 用气环境
     */
    private List<String> gasEnvironmentPic;
    /**
     * 回执单
     */
    private List<String> receiptFormPic;

    /**
     * 项目名称 开栓类型
     */
    @ExcelProperty(value = "项目名称")
    private String engineType;
    // 选择报警器、切断阀安装开栓 开始🔛
    /**
     * 表前阀前口检测
     */
    private List<String> frontPipePic;
    /**
     * 切断阀上口检测
     */
    private List<String> cutOverPipePic;
    /**
     * 切断阀下口检测
     */
    private List<String> cutUnderPipePic;
    /**
     * 报警器安装位置
     */
    private List<String> alarmPositionPic;
    // 选择报警器、切断阀安装开栓 结束🔚


//
//    /**
//     * 建筑单位
//     */
//    @ExcelProperty(value = "建筑单位")
//    private String constructUnit;
//
//    /**
//     * 项目负责人
//     */
//    @ExcelProperty(value = "项目负责人")
//    private String projectHead;
//
//    /**
//     * 现场负责人
//     */
//    @ExcelProperty(value = "现场负责人")
//    private String sceneHead;
//
//    /**
//     * 设计单位
//     */
//    @ExcelProperty(value = "设计单位")
//    private String designUnit;
//
//    /**
//     * 设计负责人
//     */
//    @ExcelProperty(value = "设计负责人")
//    private String designHead;
//
//    /**
//     * 设计联系电话
//     */
//    @ExcelProperty(value = "设计联系电话")
//    private String designPhone;
//
//    /**
//     * 监理单位
//     */
//    @ExcelProperty(value = "监理单位")
//    private String supervisionUnit;
//
//    /**
//     * 监理负责人
//     */
//    @ExcelProperty(value = "监理负责人")
//    private String supervisionHead;
//
//    /**
//     * 监理联系电话
//     */
//    @ExcelProperty(value = "监理联系电话")
//    private String supervisionPhone;
//
//    /**
//     * 类型(带气封堵施工)
//     */
//    @ExcelProperty(value = "类型(带气封堵施工)")
//    private String type;

    /**
     * 工程名称
     */
    private String enginName;

//    /**
//     * 工程分类
//     */
//    @ExcelProperty(value = "工程分类")
//    private String enginClassification;
//
//    /**
//     * 字典项
//     * municipal_engineering_node
//     * 市政工程节点类型(沟上施工|沟下施工)
//     */
//    private String municipalEngineeringNode;

    @JsonProperty("zEngineeringNodeBo")
    private ZEngineeringNodeBo zEngineeringNodeBo;

    @JsonProperty("zEngineeringNodeBoList")
    private List<ZEngineeringNodeBo> zEngineeringNodeBoList;


    private List<ZEngiineeringPhotoVo> pics;

}
